/* 
 * Upbit Open API
 *
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// WithdrawChance
    /// </summary>
    [DataContract]
    public partial class WithdrawChance :  IEquatable<WithdrawChance>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WithdrawChance" /> class.
        /// </summary>
        /// <param name="memberLevel">memberLevel.</param>
        /// <param name="currency">currency.</param>
        /// <param name="account">account.</param>
        /// <param name="withdrawLimit">withdrawLimit.</param>
        public WithdrawChance(MemberLevel memberLevel = default(MemberLevel), Currency currency = default(Currency), Account account = default(Account), WithdrawLimit withdrawLimit = default(WithdrawLimit))
        {
            this.MemberLevel = memberLevel;
            this.Currency = currency;
            this.Account = account;
            this.WithdrawLimit = withdrawLimit;
        }
        
        /// <summary>
        /// Gets or Sets MemberLevel
        /// </summary>
        [DataMember(Name="member_level", EmitDefaultValue=false)]
        public MemberLevel MemberLevel { get; set; }

        /// <summary>
        /// Gets or Sets Currency
        /// </summary>
        [DataMember(Name="currency", EmitDefaultValue=false)]
        public Currency Currency { get; set; }

        /// <summary>
        /// Gets or Sets Account
        /// </summary>
        [DataMember(Name="account", EmitDefaultValue=false)]
        public Account Account { get; set; }

        /// <summary>
        /// Gets or Sets WithdrawLimit
        /// </summary>
        [DataMember(Name="withdraw_limit", EmitDefaultValue=false)]
        public WithdrawLimit WithdrawLimit { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class WithdrawChance {\n");
            sb.Append("  MemberLevel: ").Append(MemberLevel).Append("\n");
            sb.Append("  Currency: ").Append(Currency).Append("\n");
            sb.Append("  Account: ").Append(Account).Append("\n");
            sb.Append("  WithdrawLimit: ").Append(WithdrawLimit).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WithdrawChance);
        }

        /// <summary>
        /// Returns true if WithdrawChance instances are equal
        /// </summary>
        /// <param name="input">Instance of WithdrawChance to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WithdrawChance input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.MemberLevel == input.MemberLevel ||
                    (this.MemberLevel != null &&
                    this.MemberLevel.Equals(input.MemberLevel))
                ) && 
                (
                    this.Currency == input.Currency ||
                    (this.Currency != null &&
                    this.Currency.Equals(input.Currency))
                ) && 
                (
                    this.Account == input.Account ||
                    (this.Account != null &&
                    this.Account.Equals(input.Account))
                ) && 
                (
                    this.WithdrawLimit == input.WithdrawLimit ||
                    (this.WithdrawLimit != null &&
                    this.WithdrawLimit.Equals(input.WithdrawLimit))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.MemberLevel != null)
                    hashCode = hashCode * 59 + this.MemberLevel.GetHashCode();
                if (this.Currency != null)
                    hashCode = hashCode * 59 + this.Currency.GetHashCode();
                if (this.Account != null)
                    hashCode = hashCode * 59 + this.Account.GetHashCode();
                if (this.WithdrawLimit != null)
                    hashCode = hashCode * 59 + this.WithdrawLimit.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
