/*
 * Upbit Open API
 *
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * API version: 1.0.0
 * Contact: ujhin942@gmail.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type CandleDays struct {
	// 마켓명
	Market string `json:"market,omitempty"`
	// 캔들 기준 시각 (UTC 기준)
	CandleDateTimeUtc string `json:"candle_date_time_utc,omitempty"`
	// 캔들 기준 시각 (KST 기준)
	CandleDateTimeKst string `json:"candle_date_time_kst,omitempty"`
	// 시가
	OpeningPrice float64 `json:"opening_price,omitempty"`
	// 고가
	HighPrice float64 `json:"high_price,omitempty"`
	// 저가
	LowPrice float64 `json:"low_price,omitempty"`
	// 종가
	TradePrice float64 `json:"trade_price,omitempty"`
	// 해당 캔들에서 마지막 틱이 저장된 시각
	Timestamp float32 `json:"timestamp,omitempty"`
	// 누적 거래 금액
	CandleAccTradePrice float64 `json:"candle_acc_trade_price,omitempty"`
	// 누적 거래량
	CandleAccTradeVolume float64 `json:"candle_acc_trade_volume,omitempty"`
	// 전일 종가 (UTC 0시 기준)
	PrevClosingPrice float64 `json:"prev_closing_price,omitempty"`
	// 전일 종가 대비 변화 금액
	ChangePrice float64 `json:"change_price,omitempty"`
	// 전일 종가 대비 변화량
	ChangeRate float64 `json:"change_rate,omitempty"`
	// 종가 환산 화폐 단위로 환산된 가격 (요청에 convertingPriceUnit 파라미터 없을 시 해당 필드 포함되지 않음.) 
	ConvertedTradePrice float64 `json:"converted_trade_price,omitempty"`
}
