/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * 사용자의 보안등급 정보
 */
@ApiModel(description = "사용자의 보안등급 정보")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-01-25T00:42:40.509Z")
public class MemberLevel {
  @SerializedName("security_level")
  private BigDecimal securityLevel = null;

  @SerializedName("fee_level")
  private BigDecimal feeLevel = null;

  @SerializedName("email_verified")
  private Boolean emailVerified = null;

  @SerializedName("identity_auth_verified")
  private Boolean identityAuthVerified = null;

  @SerializedName("bank_account_verified")
  private Boolean bankAccountVerified = null;

  @SerializedName("kakao_pay_auth_verified")
  private Boolean kakaoPayAuthVerified = null;

  @SerializedName("locked")
  private Boolean locked = null;

  @SerializedName("wallet_locked")
  private Boolean walletLocked = null;

  public MemberLevel securityLevel(BigDecimal securityLevel) {
    this.securityLevel = securityLevel;
    return this;
  }

   /**
   * 사용자의 보안 등급
   * @return securityLevel
  **/
  @ApiModelProperty(example = "3.0", value = "사용자의 보안 등급")
  public BigDecimal getSecurityLevel() {
    return securityLevel;
  }

  public void setSecurityLevel(BigDecimal securityLevel) {
    this.securityLevel = securityLevel;
  }

  public MemberLevel feeLevel(BigDecimal feeLevel) {
    this.feeLevel = feeLevel;
    return this;
  }

   /**
   * 사용자의 수수료 등급
   * @return feeLevel
  **/
  @ApiModelProperty(example = "0.0", value = "사용자의 수수료 등급")
  public BigDecimal getFeeLevel() {
    return feeLevel;
  }

  public void setFeeLevel(BigDecimal feeLevel) {
    this.feeLevel = feeLevel;
  }

  public MemberLevel emailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
    return this;
  }

   /**
   * 사용자의 이메일 인증 여부
   * @return emailVerified
  **/
  @ApiModelProperty(example = "true", value = "사용자의 이메일 인증 여부")
  public Boolean isEmailVerified() {
    return emailVerified;
  }

  public void setEmailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
  }

  public MemberLevel identityAuthVerified(Boolean identityAuthVerified) {
    this.identityAuthVerified = identityAuthVerified;
    return this;
  }

   /**
   * 사용자의 실명 인증 여부
   * @return identityAuthVerified
  **/
  @ApiModelProperty(example = "true", value = "사용자의 실명 인증 여부")
  public Boolean isIdentityAuthVerified() {
    return identityAuthVerified;
  }

  public void setIdentityAuthVerified(Boolean identityAuthVerified) {
    this.identityAuthVerified = identityAuthVerified;
  }

  public MemberLevel bankAccountVerified(Boolean bankAccountVerified) {
    this.bankAccountVerified = bankAccountVerified;
    return this;
  }

   /**
   * 사용자의 계좌 인증 여부
   * @return bankAccountVerified
  **/
  @ApiModelProperty(example = "true", value = "사용자의 계좌 인증 여부")
  public Boolean isBankAccountVerified() {
    return bankAccountVerified;
  }

  public void setBankAccountVerified(Boolean bankAccountVerified) {
    this.bankAccountVerified = bankAccountVerified;
  }

  public MemberLevel kakaoPayAuthVerified(Boolean kakaoPayAuthVerified) {
    this.kakaoPayAuthVerified = kakaoPayAuthVerified;
    return this;
  }

   /**
   * 사용자의 카카오페이 인증 여부
   * @return kakaoPayAuthVerified
  **/
  @ApiModelProperty(example = "false", value = "사용자의 카카오페이 인증 여부")
  public Boolean isKakaoPayAuthVerified() {
    return kakaoPayAuthVerified;
  }

  public void setKakaoPayAuthVerified(Boolean kakaoPayAuthVerified) {
    this.kakaoPayAuthVerified = kakaoPayAuthVerified;
  }

  public MemberLevel locked(Boolean locked) {
    this.locked = locked;
    return this;
  }

   /**
   * 사용자의 계정 보호 상태
   * @return locked
  **/
  @ApiModelProperty(example = "false", value = "사용자의 계정 보호 상태")
  public Boolean isLocked() {
    return locked;
  }

  public void setLocked(Boolean locked) {
    this.locked = locked;
  }

  public MemberLevel walletLocked(Boolean walletLocked) {
    this.walletLocked = walletLocked;
    return this;
  }

   /**
   * 사용자의 출금 보호 상태
   * @return walletLocked
  **/
  @ApiModelProperty(example = "false", value = "사용자의 출금 보호 상태")
  public Boolean isWalletLocked() {
    return walletLocked;
  }

  public void setWalletLocked(Boolean walletLocked) {
    this.walletLocked = walletLocked;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MemberLevel memberLevel = (MemberLevel) o;
    return Objects.equals(this.securityLevel, memberLevel.securityLevel) &&
        Objects.equals(this.feeLevel, memberLevel.feeLevel) &&
        Objects.equals(this.emailVerified, memberLevel.emailVerified) &&
        Objects.equals(this.identityAuthVerified, memberLevel.identityAuthVerified) &&
        Objects.equals(this.bankAccountVerified, memberLevel.bankAccountVerified) &&
        Objects.equals(this.kakaoPayAuthVerified, memberLevel.kakaoPayAuthVerified) &&
        Objects.equals(this.locked, memberLevel.locked) &&
        Objects.equals(this.walletLocked, memberLevel.walletLocked);
  }

  @Override
  public int hashCode() {
    return Objects.hash(securityLevel, feeLevel, emailVerified, identityAuthVerified, bankAccountVerified, kakaoPayAuthVerified, locked, walletLocked);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MemberLevel {\n");
    
    sb.append("    securityLevel: ").append(toIndentedString(securityLevel)).append("\n");
    sb.append("    feeLevel: ").append(toIndentedString(feeLevel)).append("\n");
    sb.append("    emailVerified: ").append(toIndentedString(emailVerified)).append("\n");
    sb.append("    identityAuthVerified: ").append(toIndentedString(identityAuthVerified)).append("\n");
    sb.append("    bankAccountVerified: ").append(toIndentedString(bankAccountVerified)).append("\n");
    sb.append("    kakaoPayAuthVerified: ").append(toIndentedString(kakaoPayAuthVerified)).append("\n");
    sb.append("    locked: ").append(toIndentedString(locked)).append("\n");
    sb.append("    walletLocked: ").append(toIndentedString(walletLocked)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

