# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Market Class
#'
#' @field id 
#' @field name 
#' @field order_types 
#' @field order_sides 
#' @field bid 
#' @field ask 
#' @field max_total 
#' @field state 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Market <- R6::R6Class(
  'Market',
  public = list(
    `id` = NULL,
    `name` = NULL,
    `order_types` = NULL,
    `order_sides` = NULL,
    `bid` = NULL,
    `ask` = NULL,
    `max_total` = NULL,
    `state` = NULL,
    initialize = function(`id`, `name`, `order_types`, `order_sides`, `bid`, `ask`, `max_total`, `state`){
      if (!missing(`id`)) {
        stopifnot(is.character(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!missing(`order_types`)) {
        stopifnot(is.list(`order_types`), length(`order_types`) != 0)
        lapply(`order_types`, function(x) stopifnot(is.character(x)))
        self$`order_types` <- `order_types`
      }
      if (!missing(`order_sides`)) {
        stopifnot(is.list(`order_sides`), length(`order_sides`) != 0)
        lapply(`order_sides`, function(x) stopifnot(is.character(x)))
        self$`order_sides` <- `order_sides`
      }
      if (!missing(`bid`)) {
        stopifnot(R6::is.R6(`bid`))
        self$`bid` <- `bid`
      }
      if (!missing(`ask`)) {
        stopifnot(R6::is.R6(`ask`))
        self$`ask` <- `ask`
      }
      if (!missing(`max_total`)) {
        stopifnot(is.character(`max_total`), length(`max_total`) == 1)
        self$`max_total` <- `max_total`
      }
      if (!missing(`state`)) {
        stopifnot(is.character(`state`), length(`state`) == 1)
        self$`state` <- `state`
      }
    },
    toJSON = function() {
      MarketObject <- list()
      if (!is.null(self$`id`)) {
        MarketObject[['id']] <- self$`id`
      }
      if (!is.null(self$`name`)) {
        MarketObject[['name']] <- self$`name`
      }
      if (!is.null(self$`order_types`)) {
        MarketObject[['order_types']] <- self$`order_types`
      }
      if (!is.null(self$`order_sides`)) {
        MarketObject[['order_sides']] <- self$`order_sides`
      }
      if (!is.null(self$`bid`)) {
        MarketObject[['bid']] <- self$`bid`$toJSON()
      }
      if (!is.null(self$`ask`)) {
        MarketObject[['ask']] <- self$`ask`$toJSON()
      }
      if (!is.null(self$`max_total`)) {
        MarketObject[['max_total']] <- self$`max_total`
      }
      if (!is.null(self$`state`)) {
        MarketObject[['state']] <- self$`state`
      }

      MarketObject
    },
    fromJSON = function(MarketJson) {
      MarketObject <- jsonlite::fromJSON(MarketJson)
      if (!is.null(MarketObject$`id`)) {
        self$`id` <- MarketObject$`id`
      }
      if (!is.null(MarketObject$`name`)) {
        self$`name` <- MarketObject$`name`
      }
      if (!is.null(MarketObject$`order_types`)) {
        self$`order_types` <- MarketObject$`order_types`
      }
      if (!is.null(MarketObject$`order_sides`)) {
        self$`order_sides` <- MarketObject$`order_sides`
      }
      if (!is.null(MarketObject$`bid`)) {
        bidObject <- Bid$new()
        bidObject$fromJSON(jsonlite::toJSON(MarketObject$bid, auto_unbox = TRUE))
        self$`bid` <- bidObject
      }
      if (!is.null(MarketObject$`ask`)) {
        askObject <- Ask$new()
        askObject$fromJSON(jsonlite::toJSON(MarketObject$ask, auto_unbox = TRUE))
        self$`ask` <- askObject
      }
      if (!is.null(MarketObject$`max_total`)) {
        self$`max_total` <- MarketObject$`max_total`
      }
      if (!is.null(MarketObject$`state`)) {
        self$`state` <- MarketObject$`state`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "name": %s,
           "order_types": [%s],
           "order_sides": [%s],
           "bid": %s,
           "ask": %s,
           "max_total": %s,
           "state": %s
        }',
        self$`id`,
        self$`name`,
        lapply(self$`order_types`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`order_sides`, function(x) paste(paste0('"', x, '"'), sep=",")),
        self$`bid`$toJSON(),
        self$`ask`$toJSON(),
        self$`max_total`,
        self$`state`
      )
    },
    fromJSONString = function(MarketJson) {
      MarketObject <- jsonlite::fromJSON(MarketJson)
      self$`id` <- MarketObject$`id`
      self$`name` <- MarketObject$`name`
      self$`order_types` <- MarketObject$`order_types`
      self$`order_sides` <- MarketObject$`order_sides`
      BidObject <- Bid$new()
      self$`bid` <- BidObject$fromJSON(jsonlite::toJSON(MarketObject$bid, auto_unbox = TRUE))
      AskObject <- Ask$new()
      self$`ask` <- AskObject$fromJSON(jsonlite::toJSON(MarketObject$ask, auto_unbox = TRUE))
      self$`max_total` <- MarketObject$`max_total`
      self$`state` <- MarketObject$`state`
    }
  )
)
